:: KuntaGML-rajapinnan aineistoja OGC GeoPackageen muuntava GRASS-skripti - paikkatietomies.fi 

@ECHO OFF

:: QGIS-ohjelman hakemisto
SET QGIS_KANSIO="C:\Program Files\QGIS 3.2"

:: GRASS GIS:n käynnistävän BAT-tiedoston sijainti
SET GRASS_BAT_SIJAINTI=%QGIS_KANSIO%\bin\

:: Kirjoitetaan ruudulle skriptin käynnistyksen alkusanat
ECHO KuntaGML-rajapinnan aineistoja OGC GeoPackageen muuntava GRASS-skripti - paikkatietomies.fi
ECHO GRASS GIS -paikkatietosovelluksen alustusskriptin (grass74.bat) tulee olla kansiossa %GRASS_BAT_SIJAINTI%
ECHO ---

ECHO Aloita antamalla prosessoinnissa tarvittavia tietoja (paina jotakin)
PAUSE > NUL

:: Pyydä käyttäjältä WFS-rajapinnan tietoja
SET /P WFS_GETCAPABILITIES_URL= Anna WFS-rajapinnan GetCapablities URL (lopeta kysymysmerkkiin):
SET /P WFS_TASON_NIMI= Anna muunnettavan WFS-tason nimi palvelimella:
SET /P WFS_TASON_EPSG_TUNNISTE= Anna WFS-tason EPSG-tunniste (esim. EPSG:3067 tulee antaa muodossa 3067):
SET /P ULOSKIRJOITTETAVAN_TIEDOSTON_NIMI= Anna tallennettavan GeoPackage-tiedoston nimi:
SET /P PROSESSOINTIKANSIO= Anna prosessointikansion polku (esim. C:\TEMP):

:: Tiedot annettu, ilmoitetaan käyttäjälle etenemisestä
ECHO Tarvittavat tiedot annettu. Aloita aineiston haku WFS-rajapinnasta (paina jotakin)
PAUSE > NUL
PAUSE > NUL 

:: GRASS GIS -ohjelman hakemisto
SET GISBASE=%QGIS_KANSIO%\apps\grass\grass-7.4.1

:: Prosessointikansion luonti
SET PROSESSOINTIKANSIO_POLKU=%PROSESSOINTIKANSIO%\GRASS

:: Määritellään luotu hakemisto GRASS GIS:n datahakemistoksi
SET GISDBASE=%PROSESSOINTIKANSIO_POLKU%

:: Määritellään GRASS-sijainti
SET LOCATION_NAME=GRASS_SIJAINTI

:: Määritellään GRASS-karttajoukko
SET MAPSET=KUNTAGML

:: Käynnistetään GRASS tekstitilassa
SET GUI=text

:: Luodaan prosessointihakemisto
MKDIR %PROSESSOINTIKANSIO_POLKU%

:: Luodaan GRASS GIS:n sijaintia ja karttajoukkoa varten kansiot
MKDIR %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%
MKDIR %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\PERMANENT
MKDIR %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\%MAPSET%
MKDIR %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\%MAPSET%\sqlite

:: Muodostetaan karttajoukon WIND-tiedosto
ECHO proj:       0 > %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\%MAPSET%\WIND
ECHO zone:       0 >> %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\%MAPSET%\WIND
ECHO north:      1 >> %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\%MAPSET%\WIND
ECHO south:      0 >> %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\%MAPSET%\WIND
ECHO east:       1 >> %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\%MAPSET%\WIND
ECHO west:       0 >> %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\%MAPSET%\WIND
ECHO cols:       1 >> %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\%MAPSET%\WIND
ECHO rows:       1 >> %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\%MAPSET%\WIND
ECHO e-w resol:  1 >> %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\%MAPSET%\WIND
ECHO n-s resol:  1 >> %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\%MAPSET%\WIND
ECHO top:        1 >> %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\%MAPSET%\WIND
ECHO bottom:     0 >> %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\%MAPSET%\WIND
ECHO cols3:      1 >> %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\%MAPSET%\WIND
ECHO rows3:      1 >> %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\%MAPSET%\WIND
ECHO depths:     1 >> %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\%MAPSET%\WIND
ECHO e-w resol3: 1 >> %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\%MAPSET%\WIND
ECHO n-s resol3: 1 >> %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\%MAPSET%\WIND
ECHO t-b resol:  1 >> %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\%MAPSET%\WIND

:: Muodostetaan PERMANENT-karttajoukon DEFAULT_WIND-tiedosto 
COPY %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\%MAPSET%\WIND %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\PERMANENT\DEFAULT_WIND"

:: Kopioidaan luotu WIND-tiedosto PERMANENT-karttajoukkoon
COPY %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\%MAPSET%\WIND %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\PERMANENT\WIND"

:: Muodostetaan VAR-tiedosto
ECHO DB_DRIVER: sqlite > %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\%MAPSET%\VAR
ECHO DB_DATABASE: %GISDBASE%\%LOCATION_NAME%\%MAPSET%\sqlite\sqlite.db >> %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\%MAPSET%\VAR

:: Kopioidaan VAR-tiedosto PERMANENT-karttajoukkoon
COPY %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\%MAPSET%\VAR %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\PERMANENT\VAR"

:: Määritellään GISRC-tiedoston sijainti
SET GISRC=%GISBASE%\gisrc

:: Muodostetaan GISRC-tiedosto
ECHO GISDBASE: %GISDBASE%> %GISRC%
ECHO LOCATION_NAME: %GISDBASE%\%LOCATION_NAME%>> %GISRC%
ECHO MAPSET: %GISDBASE%\%LOCATION_NAME%\%MAPSET%>> %GISRC% 
ECHO GUI: %GUI%>> %GISRC%

:: Asetaan tarvittavat polut
SET PATH=%PATH%;%QGIS_KANSIO%\bin
SET PATH=%PATH%;%GISBASE%\bin
SET PATH=%PATH%;%GISBASE%\lib
SET PATH=%PATH%;%GISBASE%\scripts

:: Luodaan kansio johon tallennetaan GeoPackage-tiedosto
MKDIR %PROSESSOINTIKANSIO_POLKU%\GPKG

:: Ajetaan GRASS GIS:n WFS-rajapintaa lukeva komento
CALL %QGIS_KANSIO%\bin\grass74.bat %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\PERMANENT --exec v.in.wfs url=%WFS_GETCAPABILITIES_URL% output=%ULOSKIRJOITTETAVAN_TIEDOSTON_NIMI% name=%WFS_TASON_NIMI% srs=EPSG:%WFS_TASON_EPSG_TUNNISTE% maximum_features=100000

:: Ajetaan GRASS GIS:n komento jolla asetetaan PERMANENT-karttajoukon sijainniksi käyttäjältä pyydetty EPSG-koodi
CALL %QGIS_KANSIO%\bin\grass74.bat %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\PERMANENT --exec g.proj --quiet -c epsg=%WFS_TASON_EPSG_TUNNISTE%

:: Ilmoitetaan käyttäjälle, että tiedot on haettu WFS-rajapinnalta
ECHO Aineisto haettu WFS-rajapinnalta. Aloitetaan aineiston kirjoitus GeoPackage-muotoon (paina jotakin)
PAUSE > NUL

:: Kirjoitetaan WFS-tason sisältö GeoPackage muotoon käyttäjän antamaan kansioon
CALL %QGIS_KANSIO%\bin\grass74.bat %PROSESSOINTIKANSIO_POLKU%\%LOCATION_NAME%\PERMANENT --exec v.out.ogr input=%ULOSKIRJOITTETAVAN_TIEDOSTON_NIMI%@PERMANENT output=%PROSESSOINTIKANSIO_POLKU%\GPKG\%ULOSKIRJOITTETAVAN_TIEDOSTON_NIMI%.gpkg format=GPKG

:: Ilmoitetaan käyttäjälle, että valmista tuli 
ECHO Valmista tuli! GeoPackage-tiedosto on tallennuttu sijaintiin: %PROSESSOINTIKANSIO_POLKU%\GPKG
PAUSE > NUL

CMD /k
